//+------------------------------------------------------------------+
//|                                                    BarryBox Indy |
//|                                                by blitzforex.xyz |
//|                                                                  |
//+------------------------------------------------------------------+

#property copyright "by uzi"
#property strict

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_plots   2

//--- plot Resistenza
#property indicator_label1  "Resistenza"
#property indicator_type1   DRAW_SECTION
#property indicator_color1  clrRed
#property indicator_style1  STYLE_SOLID
#property indicator_width1  5

//--- plot Supporto
#property indicator_label2  "Supporto"
#property indicator_type2   DRAW_SECTION
#property indicator_color2  clrLime
#property indicator_style2  STYLE_SOLID
#property indicator_width2  5

//--- input parameters
input int nBar = 100;

//--- indicator buffers
double v1[];
double v2[];

double val1;
double val2;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int OnInit()
{
   //---
   string           www  = "by uzi";
   if (ObjectFind  (www) < 0)
   {
      ObjectCreate (www, OBJ_LABEL,    0, 0, 0);
      ObjectSet    (www, OBJPROP_BACK,       true);
      ObjectSet    (www, OBJPROP_CORNER,     CORNER_RIGHT_LOWER);
      ObjectSet    (www, OBJPROP_SELECTABLE, false);
      ObjectSet    (www, OBJPROP_XDISTANCE,  25);
      ObjectSet    (www, OBJPROP_YDISTANCE,  10);
      ObjectSetText(www, www, 10, "Tahoma",  clrOrange);
   }
   
   //--- indicator buffers mapping
   SetIndexBuffer(0, v1);
   SetIndexBuffer(1, v2);
   
   //---
   return(INIT_SUCCEEDED);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
   //---
   if (rates_total > prev_calculated)
   {
      datetime tUp1 = 0, tDn2 = 0;
      
      for (int i = MathMin(nBar, rates_total); i >= 0; i--)
      {
         val1 = iFractals(NULL, 0, MODE_UPPER, i);
         if (val1 > 0) {v1[i] = High[i]; tUp1 = Time[i];}
         else           v1[i] = v1[i+1];

         val2 = iFractals(NULL, 0, MODE_LOWER, i);
         if (val2 > 0) {v2[i] = Low[i]; tDn2 = Time[i];}
         else           v2[i] = v2[i+1];
      }   

      setPrice("Price Up", tUp1, Time[0], v1[0]);
      setPrice("Price Dn", tDn2, Time[0], v2[0]); 
   }
   
   //--- return value of prev_calculated for next call
   return(rates_total);
}

int setPrice(string name, datetime t0, datetime t1, double p)
{
   name = name + " " + Symbol();
   if(ObjectFind(name) == -1)
   {
      ObjectCreate(name, OBJ_ARROW, 0, 0, 0);
      ObjectSet(name, OBJPROP_WIDTH,      1);
      ObjectSet(name, OBJPROP_COLOR,      Yellow);
      ObjectSet(name, OBJPROP_SELECTABLE, false);
      ObjectSet(name, OBJPROP_ARROWCODE,  SYMBOL_RIGHTPRICE);
   }
   ObjectMove(name, 0, t1, p);

   string line = "Line " + name;
   if (ObjectFind(line) < 0)
   {
      ObjectCreate(line, OBJ_TREND, 0, 0, 0, 0, 0);
      ObjectSet(line, OBJPROP_STYLE,      STYLE_DOT);
      ObjectSet(line, OBJPROP_WIDTH,      1);
      ObjectSet(line, OBJPROP_COLOR,      Yellow);
      ObjectSet(line, OBJPROP_SELECTABLE, false);      
      ObjectSet(line, OBJPROP_BACK,       true);
      ObjectSet(line, OBJPROP_RAY,        false);
   }
   ObjectMove(line, 0, t0, p);
   ObjectMove(line, 1, t1, p);
   
   return(0);
}
 
//+------------------------------------------------------------------+
